- NAME
- SYNOPSIS
- DESCRIPTION
- RETURN VALUES
- SEE ALSO
- HISTORY
- COPYRIGHT

# NAME

EVP_KEYEXCH_fetch, EVP_KEYEXCH_free, EVP_KEYEXCH_up_ref, EVP_KEYEXCH_provider, EVP_KEYEXCH_is_a, EVP_KEYEXCH_do_all_provided, EVP_KEYEXCH_number, EVP_KEYEXCH_names_do_all - Functions to manage EVP_KEYEXCH algorithm objects

# SYNOPSIS

     #include <openssl/evp.h>

     EVP_KEYEXCH *EVP_KEYEXCH_fetch(OPENSSL_CTX *ctx, const char *algorithm,
                                    const char *properties);
     void EVP_KEYEXCH_free(EVP_KEYEXCH *exchange);
     int EVP_KEYEXCH_up_ref(EVP_KEYEXCH *exchange);
     OSSL_PROVIDER *EVP_KEYEXCH_provider(const EVP_KEYEXCH *exchange);
     int EVP_KEYEXCH_is_a(const EVP_KEYEXCH *exchange, const char *name);
     int EVP_KEYEXCH_number(const EVP_KEYEXCH *exchange);
     void EVP_KEYEXCH_do_all_provided(OPENSSL_CTX *libctx,
                                      void (*fn)(EVP_KEYEXCH *exchange, void *arg),
                                      void *arg);
     void EVP_KEYEXCH_names_do_all(const EVP_KEYEXCH *exchange,
                                   void (*fn)(const char *name, void *data),
                                   void *data);

# DESCRIPTION

`EVP_KEYEXCH_fetch()` fetches the key exchange implementation for the given algorithm from any provider offering it, within the criteria given by the properties. See provider(7)/Fetching algorithms for further information.

The returned value must eventually be freed with `EVP_KEYEXCH_free()`.

`EVP_KEYEXCH_free()` decrements the reference count for the EVP_KEYEXCH structure. Typically this structure will have been obtained from an earlier call to `EVP_KEYEXCH_fetch()`. If the reference count drops to 0 then the structure is freed.

`EVP_KEYEXCH_up_ref()` increments the reference count for an EVP_KEYEXCH structure.

`EVP_KEYEXCH_provider()` returns the provider that exchange was fetched from.

`EVP_KEYEXCH_is_a()` checks if exchange is an implementation of an algorithm that's identifiable with name.

`EVP_KEYEXCH_number()` returns the internal dynamic number assigned to the exchange.

`EVP_KEYEXCH_names_do_all()` traverses all names for the exchange, and calls fn with each name and data.

`EVP_KEYEXCH_do_all_provided()` traverses all key exchange implementations by all activated providers in the library context libctx, and for each of the implementations, calls fn with the implementation method and data as arguments.

# RETURN VALUES

`EVP_KEYEXCH_fetch()` returns a pointer to a EVP_KEYEXCH for success or NULL for failure.

`EVP_KEYEXCH_up_ref()` returns 1 for success or 0 otherwise.

`EVP_KEYEXCH_is_a()` returns 1 of exchange was identifiable, otherwise 0.

`EVP_KEYEXCH_number()` returns an integer.

# SEE ALSO

provider(7)/Fetching algorithms, OSSL_PROVIDER(3)

# HISTORY

The functions described here were added in OpenSSL 3.0.

# COPYRIGHT

Copyright 2019 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the Apache License 2.0 (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at https://www.openssl.org/source/license.html.